$Id: Cover.lhs,v 3.5 2003/09/08 16:05:03 afc Exp $
$Log: Cover.lhs,v $
Revision 3.5  2003/09/08 16:05:03  afc
code tidyup.

Revision 3.4  2003/04/03 16:15:39  afc
fix typo

Revision 3.3  2003/04/03 14:23:50  afc
Now we allow multi-pred query extensions we have to count all
nodes. "fits" mucst check for newVarPreds. Also intervals have
been added.

Revision 3.2  2002/07/16 15:59:33  ajc99
Added AncestorFMs, fixed compose definition.

Revision 3.1  2002/05/17 15:35:42  ajc99
removed key from fucntions since we don't use it.
made fits2/subsumes more lazy in case expressions.

Revision 3.0  2002/04/04 10:41:40  ajc99
Now uses hierarchical background knowledge.

Revision 2.2  2002/02/06 15:14:05  ajc99
Added atommatch to preprocess before subsumes. Tidied code.

Revision 2.1  2001/12/07 16:38:37  ajc99
Better counting, now counts in middle of tree matter.

Revision 2.0  2001/12/04 18:30:04  ajc99
no change, just version number

Revision 1.4  2001/11/13 15:34:53  ajc99
Examples now have predicates grouped with indices.

Revision 1.3  2001/10/18 17:35:37  ajc99
fixed bug in fits. Now uses Querytrees.

Revision 1.2  2001/10/12 13:42:01  ajc99
moved Binding to ADT

Revision 1.1  2001/09/27 15:07:57  ajc99
Initial revision


> module Cover(countAssocs,fits) where

> import ADT
> import Utils(makeAncestorFMs)
> import DeepSeq

> import PackedString(unpackPS)
> import FiniteMap(emptyFM,lookupFM)


----------------------------------------------------------------
countAssocs counts occurrences of these associations in the data
--- 

> countAssocs :: [Example] -> BG -> [ModeNum] -> QueryTree
>                -> QueryTree
> countAssocs kb bg@(plainbg,hier) modes queries = 
>    let noOfExamples = toInteger (length kb)
>        treeExpandedQueries = treeExpand hier queries 
>        ancestorLookup = map (makeAncestorFMs emptyFM) hier
>    in 
>    updateN noOfExamples 
>    (countAssocs2 kb bg ancestorLookup modes noOfExamples treeExpandedQueries)

> treeExpand :: HierTrees -> QueryTree -> QueryTree
> treeExpand hier QTNil = QTNil
> treeExpand hier (QTNode pred@(Pred num args) s n mv ts) = 
>    QTNode (Pred num (map (treeArgExpand hier) args)) s n mv 
>          (map (treeExpand hier) ts)


> treeArgExpand :: HierTrees -> Arg -> Arg
> treeArgExpand hier (ArgTreeName t) = 
>    case lookupHierTree t hier of
>      Just ts -> ArgTree (t,ts)
>      Nothing -> error ("treeArgExpand: " ++ t 
>                        ++ " not found in list of trees: " 
>                        ++ show (map fstHierTreePair hier))
> treeArgExpand hier x = x


> countAssocs2 :: [Example] -> BG -> AncestorFMs -> [ModeNum] -> Integer 
>                 -> QueryTree -> QueryTree
> countAssocs2 [] bg al modes noExamples queries = queries 
> countAssocs2 (example:kb) bg al modes noExamples queries =
>    let 
>       updatedqueries = countAssocsOneExample example bg al modes [[]] queries
>    in  countAssocs2 kb bg al modes noExamples updatedqueries


We're now doing counts for just one example. 
HierTrees are only at the leaves if at all. So we only check for them
at leaf nodes. If found, then they have to be handled differently.

> countAssocsOneExample :: Example -> BG -> AncestorFMs -> [ModeNum] 
>                       -> Bindings -> QueryTree -> QueryTree

> countAssocsOneExample example bg al modes bindings QTNil = QTNil

> countAssocsOneExample example bg@(plainbg,hier) al modes bindings 
>    origtree@(QTNode pred@(Pred num args) s n mv trees)
>      = if any isArgTree args 
>        then
>         case hierCount pred (example++plainbg) bindings of
>           Just (newPred,newbindings)
>                         -> QTNode newPred (s+1) n mv 
>                            (map (countAssocsOneExample example bg al
>                            modes newbindings) trees)
>           Nothing       -> origtree
>        else 
>         case fits pred (example++plainbg) hier al modes bindings of
>           Just newbindings -> QTNode pred (s+1) n mv 
>                               (map (countAssocsOneExample example bg al
>                               modes newbindings) trees)
>           Nothing          -> origtree


--------------------------------------------------------------------
This is how we count if any of the args are likely to be tree args.
We first reset all flags in the HierTree to False. Then we see if it
fits. It might fit the example in more than one way. If it fits, it'll
return the args with the flags set in the HierTrees. We can then
update the counts in the final tree, adding 1s if the flags were set
(we don't want to add more than 1 as each example should only count
for 1).

> hierCount :: Pred -> Example -> Bindings
>           -> Maybe (Pred,Bindings)
> hierCount (Pred num args) example bindings =
>      case lookup num example of
>         Nothing -> Nothing
>         Just appropriatepreds ->
>              let 
>                 countedargs = map addTreeCounts newargs
>                 (newargs,newbindings) = hierfits appropriatepreds bindings $
>                                         map resettreeflags $
>                                         args
>                 ok          = any isTrueArg countedargs
>              in if ok then Just (Pred num countedargs,newbindings)
>                 else Nothing


> isTrueArg (ArgTree (s,ts)) = any isTrue ts
> isTrueArg _ = False
> isTrue (HierNode arg supp hasmatched ts)
>   = hasmatched || any isTrue ts

> addTreeCounts :: Arg -> Arg
> addTreeCounts (ArgTree (s,ts)) = ArgTree (s,map addTreeCounts2 ts)
> addTreeCounts x = x


> addTreeCounts2 (HierNode arg supp hasmatched ts) = 
>   if hasmatched 
>   then (HierNode arg (supp+1) hasmatched (map addTreeCounts2 ts)) 
>   else (HierNode arg  supp    hasmatched (map addTreeCounts2 ts)) 


> resettreeflags (ArgTree (name,ts)) = 
>     ArgTree (name,map resetsingletreeflags ts)
> resettreeflags x = x

> resetsingletreeflags (HierNode name num flag ts) = 
>     HierNode name num False (map resetsingletreeflags ts)
> resetsingletreeflags HierNil = HierNil

> hierfits :: [Pred] -> Bindings -> [Arg] -> ([Arg],Bindings)
> hierfits preds bindings args =
>    -- hierfits2 (head [(p,b) | p <- preds, b <- bindings]) args
>      cpsfold hierfits2 (args,[]) [(p,b) | p <- preds, b <- bindings]

> cpsfold f a [] = a
> cpsfold f a (x:xs) = f x a (\y -> cpsfold f y xs)

> hierfits2 :: (Pred,Binding) -> ([Arg],Bindings) -> 
>              (([Arg],Bindings) -> ([Arg],Bindings)) -> ([Arg],Bindings)
> hierfits2 ((Pred ename eargs),binding) (args,finalbinds) k =
>    let sargs  = foldl sub args binding
>        seargs = foldl sub eargs binding
>    in 
>    if length args == length eargs -- could eventually remove this too!
>    then let result = t_unify sargs seargs args binding in
>         case result of Nothing              -> k (args,finalbinds)
>                        Just (newargs,newbs) -> k (newargs,newbs:finalbinds)
>    else k (args,finalbinds)


> t_unify :: [Arg] -> [Arg] -> [Arg] -> Binding -> Maybe ([Arg],Binding)
> t_unify [] [] [] bs = Just ([],bs)
> t_unify ((Interval b e):xs) (ay@(Atom y):ys) (z:zs) bs =
>     let y_val = read (unAtom ay) in
>     if y_val >= b && y_val < e then   
>               case t_unify xs ys zs bs of 
>                      Just (args,newbs) -> Just (z:args, newbs)
>                      Nothing           -> Nothing
>     else Nothing
> t_unify ((Interval b e):xs) ((Var y):ys) zs bs = Nothing
> t_unify ((Atom x):xs) ((Atom y):ys) (z:zs) bs = 
>     if x == y then case t_unify xs ys zs bs of 
>                      Just (args,newbs) -> Just (z:args, newbs)
>                      Nothing           -> Nothing
>     else Nothing		      
> t_unify ((Atom x):xs) ((Var y):ys) zs bs = Nothing
> t_unify ((Var x):xs) (y:ys) (z:zs) bs = 
>     case compose (Var x, y) bs of 
>       Just newb ->
>         case t_unify (sub xs ((Var x),y)) (sub ys ((Var x), y)) zs newb of
>            Just (args,finbs) -> Just (z:args, finbs)
>            Nothing           -> Nothing
>       Nothing   -> Nothing 
> t_unify (ArgTree (tname,ts):xs) (a@(Atom y):ys) (z:zs) bs = 
>     case t_unify xs ys zs bs of 
>        Just (args,newbs) -> 
>             case treesunify ts a of
>		   Just newts -> Just ((ArgTree (tname,newts):args),newbs)
>                  Nothing    -> Nothing
>        Nothing   -> Nothing
> t_unify (ArgTree (tname,ts):xs) ((Var y):ys) zs bs = Nothing


assuming there's only one match within the trees:

> treesunify :: [HierTree] -> Arg -> Maybe [HierTree]
> treesunify [] y = Nothing
> treesunify (x:xs) y = case treesunify xs y of 
>                        Just zs -> Just (x:zs)
>                        Nothing -> case singletreeunify x y of 
>                          Just newx -> Just (newx:xs)
>                          Nothing   -> Nothing

> singletreeunify :: HierTree -> Arg -> Maybe HierTree
> singletreeunify (HierNode name num flag ts) y = 
>    if name == y then Just (HierNode name num True ts)
>    else case treesunify ts y of 
>       Just newts -> Just (HierNode name num True newts)
>       Nothing -> Nothing

-----------------------------------------------------------------

Covering. Does the association "cover" this example.
This is like subsumption. Remember to check variable bindings, all 
along all predicates.

First select just the predicates we need out of the example

> fits :: Pred -> Example -> HierTrees -> AncestorFMs -> [ModeNum] -> Bindings
>      -> Maybe Bindings
> fits pred@(Pred pname pargs) example hier al modes bindings =
>    if pname == newVarPred then
>      let [arg1, arg2] = pargs 
>          newbs = filter (doesntunify arg1 arg2) bindings in
>      if null newbs then Nothing else Just newbs
>    else  
>     case lookup pname example of 
>      Just appropriatepreds -> fits2 pred appropriatepreds hier al modes bindings
>      Nothing               -> Nothing

> doesntunify :: Arg -> Arg -> Binding -> Bool
> doesntunify v1@(Var a) v2@(Var b) binding = 
>   let b1s = v1:getsubs v1 binding
>       b2s = v2:getsubs v2 binding 
>   in and [ b1 /= b2 | b1 <- b1s, b2 <- b2s]
>   where 
>      getsubs v1@(Var v) ((x,y):binding) = 
>        case x of Var w  -> if v==w then y:getsubs y binding 
>                                    else getsubs v1 binding
>                  _      -> getsubs v1 binding
>      getsubs _ _ = []

Now test to see if the Atoms match exactly

> fits2 :: Pred -> [Pred] -> HierTrees -> AncestorFMs -> [ModeNum] 
>       -> Bindings -> Maybe Bindings
> fits2 pred@(Pred name args) preds hier al modes bindings = 
>   if any isAtom args then 
>      let ps = filter (atommatch modes args) preds
>      in if null ps then Nothing else fits3 pred ps hier al modes bindings
>   else fits3 pred preds hier al modes bindings



> atommatch :: [ModeNum] -> [Arg] -> Pred -> Bool
> atommatch modes args (Pred pnum eargs) = 
>     if hasHier modes pnum then True else atommatch2 args eargs
> atommatch2 [] []                       = True
> atommatch2 ((Atom x):xs) ((Atom y):ys) = x==y && atommatch2 xs ys
> atommatch2 (_:xs) (_:ys)               = atommatch2 xs ys

Now see if it really fits.

> fits3 :: Pred -> [Pred] -> HierTrees -> AncestorFMs -> [ModeNum] 
>          -> Bindings -> Maybe Bindings
> fits3 pred example hier al modes [] = Nothing
> fits3 pred@(Pred prednum args) example hier al modes (binding:bindings) =
>    let
>      argTreeFMs = case lookupMode modes prednum of
>                    Just (ModeNum num name args) -> map (getTree hier al) args
>                    Nothing ->  error ("hasHier: " ++ show prednum ++ 
>                     " not found in list of modes: " ++ show modes ++ "\n")
>    in
>    case subsumes pred example argTreeFMs binding of 
>        Nothing -> fits3 pred example hier al modes bindings
>        Just bss -> Just (bss ++ 
>                       (case fits3 pred example hier al modes bindings of
>                          Nothing -> []
>                          Just bss2 -> bss2))



> subsumes :: Pred -> [Pred] -> [Maybe AncestorFM] -> Binding -> Maybe Bindings
> subsumes pred [] argTreeFMs binding = Nothing
> subsumes p@(Pred name args) ((Pred ename eargs):rest) argTreeFMs binding = 
>    let sargs  = foldl sub args binding
>        seargs = foldl sub eargs binding
>        otherbss = subsumes p rest argTreeFMs binding
>    in
>    if length args == length eargs -- could eventually remove this too!
>    then let newbs = c_unify sargs seargs argTreeFMs binding 
>         in case newbs of Nothing   -> otherbss
>                          Just newb -> Just (newb: 
>                                        (case otherbss of
>                                          Nothing   -> []
>                                          Just bss2 -> bss2))
>    else subsumes p rest argTreeFMs binding


> getTree :: HierTrees -> AncestorFMs -> ModeArg -> Maybe AncestorFM
> getTree ts al (ConstTree name) = getTree2 ts al name
> getTree ts al _                = Nothing
> getTree2 :: HierTrees -> AncestorFMs -> String -> Maybe AncestorFM
> getTree2 [] [] arg = error ("getTree2: " ++ show arg ++ 
>                   " not a tree in background knowledge\n")
> getTree2 ((HierTreePair (tname,t)):hiers) (a:als) name = 
>     if tname == name then Just a else getTree2 hiers als name




> hasHier :: [ModeNum] -> Int -> Bool
> hasHier modes prednum =
>    case lookupMode modes prednum of
>      Just (ModeNum num name args) -> any isConstTree args
>      Nothing -> error ("hasHier: " ++ show prednum ++ 
>                   " not found in list of modes: " ++ show modes ++ "\n")

> lookupMode [] num = Nothing
> lookupMode (m@(ModeNum mnum mname args):rest) num =
>    if mnum == num then Just m else lookupMode rest num

----------------------------------------------------------------
c_unify : a sort of one sided unification. 

c_unify assumes equal length lists!

Very rough-and-ready.
No occurs check or anything fancy. No check that variables are unique.
Will cause problems if variables are duplicated. 
(But we don't have variables in our examples for the time being, only 
in the associations, so that's okay for now).

> c_unify :: [Arg] -> [Arg] -> [Maybe AncestorFM] -> Binding -> Maybe Binding
> c_unify [] [] [] bs = Just bs
> c_unify (ax@(Atom x):xs) (ay@(Atom y):ys) (isTree:ts) bs = 
>     case isTree of
>        Just treeFM -> if ax == ay then c_unify xs ys ts bs
>                        -- || any (isAncestor ax ay) trees
>			else case lookupFM treeFM (ax,ay) of 
>                              Just _  -> c_unify xs ys ts bs
>                              Nothing -> Nothing
>        Nothing -> if x == y then c_unify xs ys ts bs
>                   else Nothing		      
> c_unify ((Atom x):xs) ((Var y):ys) ts bs = Nothing
> c_unify ((Interval b e):xs) (ay@(Atom y):ys) (isTree:ts) bs = 
>     let y_val = read (unAtom ay) in
>     if y_val >= b && y_val < e then c_unify xs ys ts bs
>     else Nothing
> c_unify ((Interval b e):xs) ((Var y):ys) ts bs = Nothing
> c_unify ((Var x):xs) (y:ys) (t:ts) bs = 
>     case compose (Var x, y) bs of 
>        Nothing -> Nothing
>        Just newbs -> 
>          c_unify (sub xs ((Var x),y)) (sub ys ((Var x), y)) ts newbs
> c_unify x y ts bs = 
>     error ("can't do c_unify with " ++ show x ++ " and " ++  show y ++ "\n")

Substitute a binding into an argument list

> sub :: [Arg] -> (Arg,Arg) -> [Arg]


> {-# INLINE sub #-}

> sub [] (a,b) = []
> sub (x:xs) (a,b) = if x == a then b:sub xs (a,b) else x:sub xs (a,b)

Compose a new binding-pair with an old binding list

> compose :: (Arg,Arg) -> Binding -> Maybe Binding
> compose p1@(a,b) [] = Just [p1]
> compose p1@(a,b) oldbs@(p2@(c,d):xs) = 
>     if p1==p2 || a==b then Just oldbs 
>     else if c==a || d==a then Nothing 
>     else case compose p1 xs of 
>              Nothing -> Nothing
>              Just bs -> Just (p2:bs)


> isAncestor x y (HierNode name val b []) = False
> isAncestor x y (HierNode name val b ts) =
>    if x==name then any (isNode y) ts
> --      if y==name then True
> --      else any (isNode y) ts 
>    else any (isAncestor x y) ts

> isNode y (HierNode name val b ts) = y == name || any (isNode y) ts


---------------------------------------------------------------------

> updateN :: Integer -> QueryTree -> QueryTree
> updateN n QTNil = QTNil
> updateN n (QTNode pred s prevn mv trees) = 
>    QTNode pred s (prevn+n) mv (map (updateN n) trees)


--------------------------------------------------------------------


> unAtom (Atom s) = unpackPS s



