{-
$Id: CreateAttributes.hs,v 1.2 2002/07/16 16:22:00 ajc99 Exp $
$Log: CreateAttributes.hs,v $
Revision 1.2  2002/07/16 16:22:00  ajc99
uses AncestorFMs.

Revision 1.1  2002/05/27 11:26:32  ajc99
Initial revision


-}

module Main where

import ADT
import FileIO
import Cover(fits)
import Utils

import System(getArgs)
import PackedString
import IO
import FiniteMap(emptyFM)


main = 
  do args <- getArgs
     hSetBuffering stdout NoBuffering
     if length args /= 4
        then putStrLn "usage: filename patternfile chunkfrom chunkto"
        else let [filename,patternfile,chunkfrom_s,chunkto_s] = args
                 chunkfrom = (read chunkfrom_s) :: Int
	         chunkto   = (read chunkto_s) :: Int
             in
             do 
	       (modes,_,key,_,_,_,_)	
                       <-  readSettings filename   
               (bg,hiers)  <-  readBackground filename
	       let 
	         chunklist = [ (show n) | n <- [chunkfrom..chunkto] ]
                 modenums  = compileModes key modes
                 compbg    = compileBG modenums key (bg,hiers)
	         expandedmodenums = map (expandModeConsts bg) modenums   
		 ancestorFMs = map (makeAncestorFMs emptyFM) (snd compbg)

--	       putStr "parsing patterns..."
               patts <- parsepatterns modenums patternfile
--	       putStrLn (show (length patts))
--	       putStrLn "processing files..."
               process patts expandedmodenums key compbg ancestorFMs filename chunklist


-----------------------------------------------------------------------


process :: Patterns -> [ModeNum] -> Mode -> BG -> AncestorFMs -> String 
        -> [String] -> IO ()
process patts modes key bg al filebase chunklist = 
   mapM_ (dofile patts modes key bg al filebase) chunklist


dofile :: Patterns -> [ModeNum] -> Mode -> BG -> AncestorFMs -> String 
       -> String -> IO ()
dofile patts modenums key bg al filebase datachunk = 
  do kb <- readKnowledgeBase (filebase ++ datachunk)
     let kbcomp  = map (compileKB modenums key) kb
     mapM_ (doExample patts modenums key bg al) kbcomp

doExample :: Patterns -> [ModeNum] -> Mode -> BG -> AncestorFMs -> Example 
          -> IO ()
doExample patts modes key (bg,hier) al example = 
  let unAtom (Atom a) = unpackPS a in 
  case lookup 0 example of
    Nothing -> error ("no key for example:\n " ++ (show example))
    Just [Pred 0 args] -> 
        do mapM_ (hasPattA (example++bg) modes hier al [[]]) patts
           putStrLn (unAtom (head args))
    Just xs -> error ("strange result from lookup:" ++ show xs ++ "\n" ++ show example ++ "\n")

hasPattA example modes hier al bindings (Assoc preds n1 n2) = 
  hasPatt example modes hier al bindings preds

hasPatt example modes hier al bindings [] = putStr "1,"
hasPatt example modes hier al bindings (pred@(Pred pnum args):preds) =
  case (fits pred example hier al modes bindings) of
    Just newbs -> hasPatt example modes hier al newbs preds
    Nothing    -> putStr "0,"
   




