$Id: Farmer.lhs,v 3.3 2003/04/03 13:49:15 afc Exp afc $
$Log: Farmer.lhs,v $
Revision 3.3  2003/04/03 13:49:15  afc
gets the maximum var num of infrequent queries first
before checking rt them.

Revision 3.2  2002/07/16 16:24:12  ajc99
Now uses infreqs.

Revision 3.1  2002/05/17 15:38:35  ajc99
removed redundant Classes stuff. supp/conf now settings.
level2 now handled slighlty differently (no rules made for it).

Revision 3.0  2002/04/04 10:43:00  ajc99
Now uses hierarchical background knowledge.

Revision 2.3  2002/02/26 11:19:27  ajc99
Farmer just collects queries, no longer does merge. Merger now written.

Revision 2.2  2002/02/06 15:16:30  ajc99
Tidied code. Put farmfile in correct place (with full path).

Revision 2.1  2001/12/07 16:39:40  ajc99
Now uses a rulehead and makes rules only from level 3 upwards.

Revision 2.0  2001/12/04 18:39:29  ajc99
 Farmer reads and merges worker results and dumps merged data. Also
writes a farmshell script.


> module Main
> where

> import System (getArgs)
> import IO     (hPutStrLn,stderr)
> import PackedString(unpackPS)

> import ADT
> import PrettyPrint
> import FileIO
> import Dumper
> import HierLearn
> import DeepSeq
> import Utils(makeAncestorLookup)
> -- import RDSubs

> farmfile = "farmshell.hierlearn"

----------------------------------------------------------------------


> main :: IO()
> main = 
>   do 
>     args <- getArgs
>     if length args /= 4 
>	then putStrLn "usage: filename level chunks workingdir"
>	else 
>         do
>           let [filename,level_string,chunk_string,workingdir] = args
>           (modes,types,key,constraints,rh,min_supp,min_conf) 
>                       <-  readSettings filename
>           (bg,hiers)  <-  readBackground filename

>           let level       = read level_string
>               chunkmax    = read chunk_string
>		chunklist   = [ (show n) | n <- [1..chunkmax] ]
>               modenums    = compileModes key modes
>		typenums    = compileTypes key modenums types
>               compbg      = compileBG modenums key (bg,hiers)
>		compconstrs = map (compileConstraints modenums) constraints
>		comprh      = compileRuleHead modenums rh
>		expandedmodenums = map (expandModeConsts bg) modenums
>               

>           infreqs     <-  readInfreqs filename workingdir level
>           writeFarmFile filename workingdir level chunklist
>           processqueries level filename workingdir expandedmodenums 
>             typenums compbg chunklist key compconstrs comprh 
>             (min_supp,min_conf) infreqs


------------------------------------------------------------------
mapM_ prettyhier hiers

> prettyhier (name,t) = 
>    do putStrLn name 
>       prettyT t
>	putStr "\n\n"

> prettyT (HierNode name num b ts) = 
>    do putStr ((unAtom name) ++ " { ")
>       mapM_ prettyT ts
>       putStr " } "

> unAtom (Atom a) = unpackPS a

-------------------------------------------------------------------------


> processqueries level filename workingdir expandedmodenums typenums 
>   compbg chunklist key compconstrs comprh (minsupp,minconf) infreqs = 

>    if level==1 
>    then makeQueriesAndLearn filename workingdir expandedmodenums 
>            typenums compbg chunklist key compconstrs level infreqs QTNil
>    else do 
>            (currentqueries, newinfreqs) <- collectqueries minsupp filename workingdir infreqs
>                       -- collectandprune filename workingdir chunklist 
>	     if noMore currentqueries 
>	       then putStrLn (bar 60) >> putStrLn "No more associations." 
>	       else 
>		 do putStrLn (bar 60 ++ " level " ++ show (level-1))
>	            let (rules,assocs) = 
>                           if level==2 
>                           then  ([], makeAssocsOnly currentqueries)
>                           else  makeRules minconf currentqueries comprh 
>		    putStr (prettyassocs expandedmodenums key assocs)
>		    putStrLn (bar 60)
>		    putStr (prettyrules expandedmodenums key rules)
>		    makeQueriesAndLearn filename workingdir 
>		             expandedmodenums typenums compbg chunklist key
>			     compconstrs level newinfreqs currentqueries

> {-
> 		    if level == 2 
>                     then
>			  makeQueriesAndLearn filename workingdir 
>		             expandedmodenums typenums compbg chunklist key
>			     compconstrs level currentqueries
>		      else
>			let (rules,assocs) = 
>                               makeRules minconf currentqueries comprh in
>			do
>			  putStr (prettyassocs expandedmodenums key assocs)
>			  putStrLn (bar 60)
>			  putStr (prettyrules expandedmodenums key rules)
>			  makeQueriesAndLearn filename workingdir 
>		             expandedmodenums typenums compbg chunklist key
>			     compconstrs level currentqueries
> -}

----------------------------------------------------------------------
makeQueriesAndLearn deals with generating/specialising associations

> makeQueriesAndLearn :: String -> String -> [ModeNum] ->[TypeNum] -> BG 
>                         -> [String] -> Mode 
>                         -> ConstraintNums
>                         -> Int -> [[Pred]] -> QueryTree -> IO()

> makeQueriesAndLearn filename workingdir modenums typenums bg@(bgnorm,hier) 
>    chunklist key constrs level infrequents prevqueries
>    = let
>        namedAncestorFMs = makeAncestorLookup hier
>        maxInfreqVar = getMaxInfreqVar infrequents
>        newqueries  = if isQTNil prevqueries 
>                       then genInitials modenums key typenums constrs 
>                              namedAncestorFMs infrequents maxInfreqVar
>		        else specialise modenums typenums constrs 
>                              namedAncestorFMs infrequents maxInfreqVar
>                                       [] prevqueries
>  --    cleanedqueries = pruneNils $ fst $ removeDuplicates [] (newqueries,[])
>        cleanedqueries = newqueries
>      in 
>      do dumpData filename workingdir (show level) modenums bg key 
>               cleanedqueries
>         writeInfreqs filename workingdir level infrequents 


----------------------------------------------------------------------

Writes a file for farmshell to use on the workers

> writeFarmFile :: String -> String -> Int -> [String] -> IO()
> writeFarmFile filename workingdir level chunklist =
>   let fullfarmfile = workingdir ++ "/" ++ farmfile in
>   do
>     writeFile fullfarmfile "taskList {\n"
>     mapM (dochunk fullfarmfile filename workingdir level) chunklist 
>     appendFile fullfarmfile "}\n"

> dochunk fullfarmfile filename workingdir level chunkname = 
>   appendFile fullfarmfile ("\"Worker " ++ filename 
>                           ++ " " ++ show level ++ " " ++ chunkname 
>                           ++ " " ++ workingdir ++ " +RTS -K5M\"\n") 


---------------------------------------------------------------------


> {-
> collectandprune :: String -> String -> [String] -> IO(QueryTree)
> collectandprune filename workingdir chunks = 
>    do
>      queries <- collectqueryfiles filename workingdir chunks
>      return (pruneTree queries)



> collectqueryfiles :: String -> String -> [String] -> IO(QueryTree)
> collectqueryfiles filename workingdir [] = 
>    error "collectqueryfiles: no chunks to collect"
> collectqueryfiles filename workingdir [x] = 
>    do
>       q <- undumpQueries (filename ++ "." ++ x) workingdir
>       hPutStrLn stderr x
>       return $!! q
> collectqueryfiles filename workingdir (x:xs) =
>    do
>       tree1 <- collectqueryfiles filename workingdir xs
>       tree2 <- undumpQueries (filename ++ "." ++ x) workingdir
>       hPutStrLn stderr x
>       return $!! (mergeTree tree1 tree2) 
> -}


> collectqueries minsupp filename workingdir oldinfreqs = 
>     do q <- undumpQueries (filename ++ ".merged") workingdir
>        return $!! (expandAndPruneTree minsupp oldinfreqs q)
