$Id: HierLearn.lhs,v 3.5 2003/09/08 16:12:05 afc Exp $
$Log: HierLearn.lhs,v $
Revision 3.5  2003/09/08 16:12:05  afc
Bugfixes.

Revision 3.4  2003/04/03 13:41:58  afc
Now has NewVars. Also multi-predicte specialisations to queries
to cope with NewVars. Added Intervals. Got rid of bignum.

Revision 3.3  2002/07/16 16:26:41  ajc99
Now uses infreqs and AncestorFMs

Revision 3.2  2002/05/27 11:17:25  ajc99
Now makes patterns from all frequent nodes of tree, not just frontier.

Revision 3.1  2002/05/17 15:42:40  ajc99
supp/conf now passed around as parameters. makeAssocsOnly added.

Revision 3.0  2002/04/04 10:44:23  ajc99
Now uses hierarchical background knowledge.

Revision 2.2  2002/02/06 15:19:58  ajc99
Added PackedString, and bignum as support and num for key.

Revision 2.1  2001/12/07 16:36:56  ajc99
classes aren't in Querytree any more. New rule-making fns. Better
constraints.

Revision 2.0  2001/12/04 18:38:31  ajc99
removed main function and changed others. Now use Farmer and Worker
instead. HierLearn is now an auxiliary file.

Revision 1.5  2001/11/12 18:05:49  ajc99
moved compile* functions out into FileIO. Now uses DeepSeq.

Revision 1.4  2001/11/06 17:58:42  ajc99
Added proper support for constraints.

Revision 1.3  2001/11/06 15:52:31  ajc99
allows constants in modes to be generated from bg file.

Revision 1.2  2001/10/18 17:36:18  ajc99
Now uses QueryTrees.

Revision 1.1  2001/09/27 15:01:19  ajc99
Initial revision


> module HierLearn(noMore, specialise, genInitials, makeRules, makeAssocsOnly,
>                  pruneTree, expandAndPruneTree, getMaxInfreqVar )


> where

> import Ratio
> import PackedString(packString)
> import List(nub)
  
> import ADT
> import Cover
> import InfrequentCheck(isntInfrequent,getMaxInfreqVar)

> -- import RDSubs(rdsubsumes)

> -- import IOExts(trace)

-------------------------------------------------------------------
This is a hack at the moment!

> -- bignum = 100000

--------------------------------------------------------------------

noMore queries should be true if there's only the key query left in 
the tree and no branches

> noMore :: QueryTree -> Bool
> noMore QTNil                          = True
> noMore (QTNode (Pred 0 _) _ _ _ [])   = True
> noMore _                              = False 



------------------------------------------------------------------------
specialise takes a querytree, and makes all possible
specialisations of it by adding one predicate.

> specialise :: [ModeNum] -> [TypeNum] -> ConstraintNums 
>               -> [(String,AncestorFM)] -> [[Pred]] -> MaxVar -> [Pred] 
>               -> QueryTree -> QueryTree

> specialise m t c fm i miv a QTNil = 
>        error "specialise: specialising a nil tree"

> specialise modenums typenums constrs namedAncestorFMs infrequents miv 
>           accpreds (QTNode pred s n maxvar []) = 
>    let pathpreds = pred:accpreds
>        newps     = genCands maxvar pathpreds modenums typenums constrs 
>        notIps    = filter (isntInfrequent pathpreds infrequents miv 
>                           modenums namedAncestorFMs) newps
>    --    notpathduplicates = filter (notinpath pathpreds) notIps
>    --    notinpath pathpreds (xs,mv) = not null (
>        notpathduplicates = notIps 
>    in if null notpathduplicates then QTNil else
>        QTNode pred 0 0 maxvar
>           [ createNodes ps m  | (ps,m) <- notpathduplicates]

> specialise modenums typenums constrs namedAncestorFMs infrequents miv 
>            accpreds (QTNode pred s n maxvar trees) = 
>    let newtrees = filter notQTNil $
>                   map (specialise modenums typenums constrs  
>                   namedAncestorFMs infrequents miv (pred:accpreds)) trees 
>    in 
>    if null newtrees then QTNil else QTNode pred 0 0 maxvar newtrees

creates nodes from a list of predicates

> createNodes [p]    m = QTNode p 0 0 m []
> createNodes (p:ps) m = QTNode p 0 0 m [ createNodes ps m ]


------------------------------------------------------------------------
genInitials makes the initial associations (for level 1 only). It 
uses the key to start things off.

> genInitials :: [ModeNum] -> Mode -> [TypeNum] -> ConstraintNums 
>                -> [(String,AncestorFM)] -> [[Pred]] -> MaxVar -> QueryTree
> genInitials modenums key typenums constrs namedAncestorFMs infrequents miv = 
>        let Mode name args = key 
> 	     maxVars        = length args 
>            ps             = [Pred 0 [Var v | v <- [1..maxVars]]] 
>            keyqt          = QTNode (Pred 0 [Var v | v <- [1..maxVars]]) 0 0 
>                             maxVars []
>        in specialise modenums typenums constrs namedAncestorFMs 
>                      infrequents miv [] keyqt



------------------------------------------------------------------------
genCands and genAll make new predicates to add onto current association.

> genCands :: MaxVar -> [Pred] -> [ModeNum] -> [TypeNum] -> ConstraintNums 
>          -> [([Pred],MaxVar)]
> genCands maxvar preds modenums typenums constrs =	
>    concat [ genAll maxvar preds m typenums | m <- modenums,
>                                         noConstraint constrs m preds]

> noConstraint constrs (ModeNum num name args) ps =
>    not ( any (constr num) ps ) && nottoomany (limit constrs num) num ps
>     where constr mnum (Pred pnum args) = constraint constrs mnum pnum
>           limit [] num = 1
>           limit ((ConstraintNumLim num2 lim):rest) num = 
>               if num == num2 then lim else limit rest num
>           limit (_:rest) num = limit rest num
>           nottoomany lim num ps = if countpreds num ps < lim 
>                                   then True else False
>           countpreds num [] = 0
>           countpreds num ((Pred num2 args):rest) = 
>            if num == num2 then 1+countpreds num rest else countpreds num rest


> constraint :: ConstraintNums -> Int -> Int -> Bool
> constraint [] x y = False
> constraint ((ConstraintNumPair (a,b)):rest) x y = 
>    if a==x && b==y then True else constraint rest x y
> constraint (_:rest) x y = constraint rest x y


makePreds within genAll first makes the predicate we want and then
makes any newVarPreds that are needed if this predicate introduces new
variables. A new variable (NewVar) is one that the user has specified
should have a different value to all existing variables of that type).

> genAll :: MaxVar -> [Pred] -> ModeNum -> [TypeNum] -> [([Pred],MaxVar)]
> genAll maxVar preds (ModeNum num name mArgs) typenums =
>     let numberedArgs = (zip [1..] mArgs) in 
>     [ (makePreds num args, v) | 
>               (v,args) <- makeCombs num numberedArgs maxVar preds typenums]
>     where
>       makePreds num args = Pred num (map newVarToVar args) :
>                    [Pred newVarPred [Var a, b] |  
>                        (NewVar a,t) <- filter (isNewVar.fst) 
>                                       (zip args (getArgTypes typenums num)), 
>                        (b,_)        <- nub (sametypevar t preds typenums)]
>       newVarToVar (NewVar a) = Var a
>       newVarToVar x          = x
>       isNewVar (NewVar a) = True
>       isNewVar _          = False


sametypevar: This checks which variables in the previous predicates
are of the type we're looking for. There may be duplicates in the result.

> sametypevar t [] types = []
> sametypevar t (Pred num args:ps) types = 
>   filter isOK ((zip args (getArgTypes types num)) ++ sametypevar t ps types)
>   where isOK (Var v,s) = s==t
>         isOK _ = False

----------------------------------------------------------------
makeCombs makes all combinations of variables and atoms from the 
mode arguments
---
Need to check each argument whether it's plus or minus. Then either
use variables or use constants from the knowledge base. If plus it
must be the same as a previous variable. If minus it must be a new
variable.

If Plus:  foreach var in [1..MaxVar] arg can be var, or any consts of 
          right type
If Minus: make new Var numbered MaxVar+1. update MaxVar.  
If PlusMinus: do both plus and minus
If NotExisting: make NewVar numbered MaxVar+1. update MaxVar. 
If ConstList: add all consts

Is it right that new plus arguments can be bound to the new Minus 
arguments that have just been made?


> makeCombs :: Int -> [(Int,ModeArg)] -> MaxVar -> [Pred] -> [TypeNum] 
>           -> [(Int, [Arg])]

> makeCombs modenum [] maxVar preds typenums = [(maxVar,[])]

> makeCombs modenum ((n,Plus):rest) maxVar preds typenums =
>   let otherargs = makeCombs modenum rest maxVar preds typenums in
>   [ (v, (Var i) : p) | i <- [1..maxVar] ,
>                        correctVarType i n modenum typenums preds, 
>                        (v,p) <- otherargs]
>   ++ [ (v, a : p) | a <- correctAtomTypes n modenum typenums preds, 
>                            (v,p) <- otherargs]
>   ++ [ (v, a : p) | a <- correctIntervalTypes n modenum typenums preds, 
>                            (v,p) <- otherargs]

> makeCombs modenum ((n,Minus):rest) maxVar preds typenums = 
>   let 
>       otherargs = makeCombs modenum rest maxVar preds typenums in
>   [ (newMaxVar+1, (Var (newMaxVar+1)) : p) | (newMaxVar,p) <- otherargs]

> makeCombs modenum ((n,PlusMinus):rest) maxVar preds typenums = 
>   makeCombs modenum ((n,Plus):rest) maxVar preds typenums 
>   ++ makeCombs modenum ((n,Minus):rest) maxVar preds typenums  

> makeCombs modenum ((n,NotExisting):rest) maxVar preds typenums = 
>   let 
>       otherargs =  makeCombs modenum rest maxVar preds typenums in
>   [ (newMaxVar+1, (NewVar (newMaxVar+1)) : p) | (newMaxVar,p) <- otherargs]


> makeCombs modenum ((n,ConstList cs):rest) maxVar preds typenums = 
>   let otherargs =  makeCombs modenum rest maxVar preds typenums in 
>   [ (v, (Atom (packString c)) : p) | c <- cs , (v,p) <- otherargs]

> makeCombs modenum ((n,ConstTree t):rest) maxVar preds typenums = 
>   let otherargs =  makeCombs modenum rest maxVar preds typenums in 
>   [ (v, (ArgTreeName t) : p) |  (v,p) <- otherargs]

> makeCombs modenum ((n,IntervalList ins):rest) maxVar preds typenums = 
>   let otherargs =  makeCombs modenum rest maxVar preds typenums in 
>   [ (v, (Interval b e) : p) | (b,e) <- ins , (v,p) <- otherargs]


------------------

Is the variable of the correct type? Look up the arg position of the
variable then find out its type.

> correctVarType :: Int -> Int -> Int -> [TypeNum] -> [Pred] -> Bool
> correctVarType varnum argnum num typenums preds =
>    let pfound = lookupPredPos varnum preds in
>      case pfound of 
>          Nothing            -> True
>          Just (pname, ppos) -> isMatchingType typenums num argnum pname ppos

Skip over newVarPreds - they're not useful

> lookupPredPos :: Int -> [Pred] -> Maybe (Int, Int)
> lookupPredPos varnum [] = Nothing
> lookupPredPos varnum ((Pred name args):rest) =
>   if name == newVarPred then lookupPredPos varnum rest else
>   let n = findVarNum varnum 1 args in
>   if n > 0 then Just (name, n) else lookupPredPos varnum rest

> findVarNum :: Int -> Int -> [Arg] -> Int
> findVarNum _ _ [] = 0
> findVarNum v n ((Var v2):rest) = if v == v2 then n 
>                                  else findVarNum v (n+1) rest
> findVarNum v n (x:rest) = findVarNum v (n+1) rest

Is arg at pos1 in pred num1 same type as arg at pos2 of pred num2?
We have to check separately for newVarPred, which doesn't have a type.

> isMatchingType :: [TypeNum] -> Int -> Int -> Int -> Int -> Bool
> isMatchingType typenums num1 pos1 num2 pos2 = 
>    if num1 == newVarPred || num2 == newVarPred then False
>    else let 
>           t1 = (getArgTypes typenums num1) !! (pos1-1) 
>           t2 = (getArgTypes typenums num2) !! (pos2-1) 
>         in t1 == t2


--------------------

> correctAtomTypes :: Int -> Int -> [TypeNum] -> [Pred] -> [Arg] 
> correctAtomTypes argnum num typenums [] = []
> correctAtomTypes argnum num typenums ((Pred pname pargs):rest) =
>   let newatoms =
>           map snd  $
>           filter (\(n,a) -> isMatchingType typenums num argnum pname n) $
>           filter isAtomP $
>           (zip [1..] pargs)
>   in foldr insertUniq (correctAtomTypes argnum num typenums rest) newatoms

> isAtomP :: (a,Arg) -> Bool
> isAtomP (_,Atom _) = True
> isAtomP _          = False

> insertUniq :: Ord a => a -> [a] -> [a]
> insertUniq x [] = [x]
> insertUniq x l@(y:ys) = if x < y then x:l
>			  else if x == y then l
>			  else y:insertUniq x ys			  


> correctIntervalTypes :: Int -> Int -> [TypeNum] -> [Pred] -> [Arg] 
> correctIntervalTypes argnum num typenums [] = []
> correctIntervalTypes argnum num typenums ((Pred pname pargs):rest) =
>   let newints =
>           map snd  $
>           filter (\(n,i) -> isMatchingType typenums num argnum pname n) $
>           filter isIntervalP $
>           (zip [1..] pargs)
>   in foldr insertUniq (correctIntervalTypes argnum num typenums rest) newints

> isIntervalP :: (a,Arg) -> Bool
> isIntervalP (_,Interval _ _) = True
> isIntervalP _                = False


--------------------------------------------------------------
makeRules converts associations into rules
---

Rules can only be made by branches where the rulehead is at the leaf. 
This is because we need support of the whole thing and support of the 
subpart too.

> makeAssocsOnly :: QueryTree -> [Assoc]
> makeAssocsOnly (QTNode p s n mv trees) = concatMap makeAssocsMid trees

> makeRules :: Ratio Integer -> QueryTree -> RuleHead -> ([Rule],[Assoc])
> makeRules minconf (QTNode p s n mv trees) Nothing = 
>   ([],concatMap makeAssocsMid trees) 
> makeRules minconf qt@(QTNode p s n mv trees) (Just rh) =
>   let assocs         = concatMap makeAssocsMid trees
>       toberuleassocs = filter (wouldMakeRule rh) assocs
>       rassocs = zip (map (findSubset rh trees) toberuleassocs) toberuleassocs
>       rules          = map (extractrules rh) rassocs
>   in 
>   (filter (isGoodRule minconf) rules,assocs)


> wouldMakeRule rh (Assoc ps s n) = isPred rh (last ps)
>  where isPred rh (Pred n args) = n==rh




> extractrules rh ((s1,n1),Assoc ps s2 n2) =
>     case  extracthead rh ps of
>        (Just head,body) -> Rule s1 n1 s2 n2 head body
>        (Nothing,b)      -> error ("extractrules: can't extract " 
>                                   ++ show rh ++ " from " ++ show ps ++ "\n")

> extracthead rh (ph@(Pred p args):rest) = 
>     if rh == p then (Just ph,rest) 
>     else case extracthead rh rest of 
>                   (Just h,b)  -> (Just h,ph:b)
>                   (Nothing,b) -> (Nothing,b)
> extracthead rh [] = (Nothing,[])

> findSubset :: Int -> [QueryTree] -> Assoc -> (Integer, Integer) 
> findSubset rh ts (Assoc ps s n) = 
>   let shortps = removeRH rh ps in
>   case findInTrees ts shortps of
>      Just (s,n) -> (s,n)
>      Nothing    -> error ("findSubset: trying to find " ++ (show shortps) 
>                           ++ " in " ++ show ts ++ "\n")

> removeRH rh [] = []
> removeRH rh (p@(Pred n args):rest) = if rh == n then rest 
>                                            else p:removeRH rh rest

> findSubset2 :: QueryTree -> [Pred] -> Maybe (Integer,Integer)
> findSubset2 (QTNode p1 s n mv []) [p2] = 
>    if p1 == p2 then Just (s,n) else Nothing
> findSubset2 (QTNode p1 s n mv trees) [p2] = 
>    if p1 == p2 then Just (s,n) else Nothing
> findSubset2 (QTNode p1 s n mv trees) ps = 
>    case isIn p1 ps of
>      Just newps -> case findInTrees trees newps of
>                       Just (s,n) -> Just (s,n)
>			Nothing    -> Nothing
>      Nothing -> Nothing


> findInTrees :: [QueryTree] -> [Pred] -> Maybe (Integer,Integer)
> findInTrees [] ps     = Nothing
> findInTrees (t:ts) ps = case findSubset2 t ps of
>                              Just (s,n) -> Just (s,n)
>                              Nothing -> findInTrees ts ps




> isIn          :: Eq a => a -> [a] -> Maybe [a] 
> isIn x []     = Nothing
> isIn x [y]    = if x == y then Just [] else Nothing
> isIn x (y:ys) = if x==y then Just ys 
>                 else case isIn x ys of Just zs -> Just (y:zs)
>                                        Nothing -> Nothing


Makes all associations from trees (we assume we have lost the very
root node by now, because the root was kind of a dummy anyway

> makeAssocsMid :: QueryTree -> [Assoc]
> makeAssocsMid  QTNil                  = []
> makeAssocsMid (QTNode p s n mv [])    = [Assoc [p] s n]
> makeAssocsMid (QTNode p s n mv trees) =
>      let assocs = concatMap makeAssocsMid trees
>          addpred p (Assoc ps s n) = Assoc (p:ps) s n
>      in map (addpred p) assocs


> isGoodRule minconf (Rule s1 n1 s2 n2 headr body) = 
>   let zeroconf = if s1 == 0 then 0 else s2 % s1 in
>   zeroconf >= minconf



-- Utils ------------------------------------------------------------
---------------------------------------------------------------------


applyn applies a function n times (n > 0)

> applyn :: Int -> (a -> a) -> (a -> a)
> applyn 1 f = f
> applyn n f = f . applyn (n-1) f



----------------------------------------------------------------------

Pruning the QueryTree

This prunes off branches below the support threshold. Branches that
are pruned are replaced by QTNil, then these QTNils get propagated
back up the tree until a node doesn't have only QTNils as children.
Handily, this means that predicates that are added as a group and form
a long thin branch get pruned right back if any of them fail.

> pruneTree :: Ratio Integer -> [[Pred]] -> [Pred] -> QueryTree -> (QueryTree,[[Pred]])
> pruneTree minsupp infreqs accpreds QTNil = (QTNil,infreqs)
> pruneTree minsupp infreqs accpreds t@(QTNode pred s n maxvar []) = 
>    let zerosupp = if s == 0 then 0 else (s % n) 
>    in if zerosupp < minsupp then (QTNil,(pred:accpreds):infreqs) 
>       else (t,infreqs)
> pruneTree minsupp infreqs accpreds (QTNode pred s n maxvar trees) = 
>    let zerosupp = if s == 0 then 0 else (s % n) 
>    in if zerosupp < minsupp 
>       then (QTNil,(concatMap (finishpaths (pred:accpreds)) trees) ++ infreqs)
>       else let ts = (map (pruneTree minsupp [] (pred:accpreds)) trees)
>                newts = map fst (filter (notQTNil.fst) ts)
>                newinfreqs = concatMap snd ts
> --            in if null newts then (QTNil,(pred:accpreds):infreqs)
>            in if null newts then (QTNil,newinfreqs ++ infreqs)
>            else (QTNode pred s n maxvar newts, newinfreqs ++ infreqs)
>    where 
>       finishpaths path (QTNode p s n mv []) = [p:path]
>       finishpaths path (QTNode p s n mv ts) = 
>                   concatMap (finishpaths (p:path)) ts

we need to first filter the counts up the trees, then prune to give 
individuals. Expand out to normal, then pruneTree.

> expandAndPruneTree minsupp infreqs t =
>   let p = pruneHierTreeCounts minsupp t 
>       e = expandout p
>       h = head e
>       (pt,newinfreqs) = pruneTree minsupp infreqs [] h 
>   in
>   (pt, newinfreqs)

> pruneHierTreeCounts :: Ratio Integer -> QueryTree -> QueryTree
> pruneHierTreeCounts minsupp QTNil = QTNil
> pruneHierTreeCounts minsupp (QTNode pred s n maxvar ts) =
>    QTNode (pruneHierTree minsupp n pred) s n maxvar 
>             (map (pruneHierTreeCounts minsupp) ts)


> pruneHierTree minsupp n (Pred name args) = 
>    Pred name (map (pruneArgs minsupp n) args)

> pruneArgs minsupp n (ArgTree (name,ts)) = 
>     (ArgTree (name, map (pruneTreeCounts minsupp n) ts))
> pruneArgs minsupp n x = x

> pruneTreeCounts minsupp n leaf@(HierNode name v b []) = 
>   if v%n >= minsupp then leaf else HierNil
> pruneTreeCounts minsupp n (HierNode name v b ts) =
>   let 
>       children = filter notHierNil (map (pruneTreeCounts minsupp n) ts)
>   in
>       if v%n >= minsupp 
>        then HierNode name v b children 
>        else HierNil





> expandout :: QueryTree -> [ QueryTree ]
> expandout QTNil = [QTNil]
> expandout (QTNode (Pred name args) s n mv ts) = 
>   let argset args = map unzip (allcombs ( map expand args )) in
>    [QTNode (Pred name a) (if ms==(-1) then s else ms) n mv 
>       (concatMap expandout ts) 
>         | (supps,a) <- argset args, let ms = minimum supps ]




-----------------------------------------------------------------------

Cross product of a list of lists

> allcombs [] = [[]]
> allcombs (xs:xss) = [x:ys | x <- xs, ys <-allcombs xss]

> expand :: Arg -> [(Integer,Arg)]
> expand (ArgTree (name,ts)) = concatMap bodyandfrontier ts 
> expand x = [(-1,x)]

Just the leaves of the tree

> frontier HierNil = []
> frontier (HierNode name s b []) = [(s,name)]
> frontier (HierNode name s b ts) = concatMap frontier ts

All the tree, not just the leaves

> bodyandfrontier HierNil = []
> bodyandfrontier (HierNode name s b []) = [(s,name)]
> bodyandfrontier (HierNode name s b ts) = 
>     (s,name):concatMap bodyandfrontier ts

Test if a QueryTree has an ArgTree in it

> qthasatreearg (QTNode pred s n mv ts) = hasatreearg pred
> hasatreearg (Pred name args) = any isArgTree args

