$Id: InfrequentCheck.lhs,v 1.3 2003/09/08 16:22:55 afc Exp $
$Log: InfrequentCheck.lhs,v $
Revision 1.3  2003/09/08 16:22:55  afc
handles newVarPred. subsumes returns Maybe bindings

Revision 1.2  2003/04/03 13:36:24  afc
Now does variable replacement once only. Tiedied up subsumption
code.

Revision 1.1  2002/07/16 16:27:42  ajc99
Initial revision


> module InfrequentCheck( isntInfrequent, 
>                         makeAncestorLookup, 
>                         subsumes,
>                         getMaxInfreqVar )
> where


> import Maybe(fromJust,isJust)
> import PackedString(unpackPS)
> import FiniteMap

> import ADT
> import Utils


> isntInfrequent :: [Pred] -> [[Pred]] -> MaxVar -> [ModeNum] 
>                    -> [(String,AncestorFM)] -> ([Pred],MaxVar) -> Bool
> isntInfrequent pathpreds infrequents miv modes hiertrees (preds,maxvar) = 
>    let currentquery = replaceAllVarsInQuery miv (preds ++ pathpreds) 
>    in
>    all (isntSubsumedBy currentquery modes hiertrees) infrequents


> isntSubsumedBy :: [Pred] -> [ModeNum] -> [(String,AncestorFM)] -> [Pred] 
>                -> Bool
> isntSubsumedBy squery modes hiertrees infrequentquery = 
>   case subsumes squery infrequentquery [[]] modes hiertrees of
>     Just bindings -> 
>        let nvps = getNewVarPredArgs infrequentquery 
>        in null (filter (differentvars nvps) bindings) 
>     Nothing -> True


> differentvars [] binding = True
> differentvars (args:argss) binding = 
>     let [a1,a2] =  foldl sub args binding in
>     a1 /= a2   && differentvars argss binding


> subsumes squery [] bindings modes hiertrees = Just bindings
> subsumes squery ((Pred n args):iquery) bindings modes hiertrees = 
>    if n == newVarPred 
>    then subsumes squery iquery bindings modes hiertrees
>    else
>     let 
>       ps          = getAppropriatePreds n squery
>       ancestorFMs = align n modes hiertrees
>       bs = concatMap (testunify args ancestorFMs bindings) (map getPArgs ps)
>       newbs       = map fromJust (filter isJust bs)
>     in
>     if not (null newbs) then subsumes squery iquery newbs modes hiertrees
>     else Nothing


> getNewVarPredArgs [] = []
> getNewVarPredArgs ((Pred n args):ps) = 
>   if n == newVarPred then args:getNewVarPredArgs ps else getNewVarPredArgs ps


This function (doesntunify) same as in Cover.lhs  - not used here

 > doesntunify :: Arg -> Arg -> Binding -> Bool
 > doesntunify v1@(Var a) v2@(Var b) binding = 
 >   let b1s = v1:getsubs v1 binding
 >       b2s = v2:getsubs v2 binding 
 >   in and [ b1 /= b2 | b1 <- b1s, b2 <- b2s]
 >   where 
 >      getsubs v1@(Var v) ((x,y):binding) = 
 >        case x of Var w  -> if v==w then y:getsubs y binding 
 >                                    else getsubs v1 binding
 >                  _      -> getsubs v1 binding
 >      getsubs _ _ = []


> testunify :: [Arg] -> [Maybe AncestorFM] -> [Binding] -> [Arg] 
>           -> [Maybe Binding]
> testunify gargs ancestorfms [] sargs = []
> testunify gargs ancestorfms (binding:bindings) sargs =
>    let sgargs = foldl sub gargs binding
>        ssargs = foldl sub sargs binding in
>    (unify sgargs ssargs ancestorfms binding) :
>    testunify gargs ancestorfms bindings sargs

> getAppropriatePreds n = filter (isPNum n)
>  where isPNum x (Pred y args) = x==y

> align :: Int -> [ModeNum] -> [(String,AncestorFM)] -> [Maybe AncestorFM]
> align prednum modes ancestorfms =
>    if prednum == newVarPred then [Nothing,Nothing] else
>    let ms = fromJust $ lookupModeArgs prednum modes in
>    map (align2 ancestorfms) ms 

> align2 :: [(String,AncestorFM)] -> ModeArg -> Maybe AncestorFM
> align2 ancestorfms (ConstTree name) = 
>   lookup name ancestorfms
> align2 ancestorfms _ = Nothing

> lookupModeArgs num [] = Nothing
> lookupModeArgs num ((ModeNum mnum mname margs):modenums) =
>   if num == mnum then Just margs else lookupModeArgs num modenums


----------------------------------------------------------------------


> unify :: [Arg] -> [Arg] -> [Maybe AncestorFM] -> Binding -> Maybe Binding
> unify [] [] [] bs = Just bs
> unify (ax@(Atom x):xs) (ay@(Atom y):ys) (isTree:ts) bs = 
>     case isTree of
>        Just treeFM -> if ax == ay then unify xs ys ts bs
>                        -- || any (isAncestor ax ay) trees
>			else case lookupFM treeFM (ax,ay) of 
>                              Just _  -> unify xs ys ts bs
>                              Nothing -> Nothing
>        Nothing -> if x == y then unify xs ys ts bs
>                   else Nothing	
> unify (ax@(Atom x):xs) (ay@(ArgTreeName y):ys) (isTree:ts) bs = Nothing
> unify ((Atom x):xs) ((Interval b e):ys) ts bs = Nothing
> unify ((Atom x):xs) ((Var y):ys) ts bs = Nothing
> unify ((Interval b e):xs) ((Atom y):ys) (isTree:ts) bs =
>     let y_val = read (unpackPS y) in
>     if y_val >= b && y_val < b then unify xs ys ts bs
>     else Nothing
> unify ((Interval b e):xs) ((Var y):ys) ts bs = Nothing
> unify (i1@(Interval b1 e1):xs) (i2@(Interval b2 e2):ys) (isTree:ts) bs =
>     if i1 == i2 then unify xs ys ts bs else Nothing
> unify ((Var x):xs) (y:ys) (t:ts) bs = 
>     let mnewbs = compose (Var x, y) bs in
>     case mnewbs of 
>        Nothing -> Nothing
>        Just newbs -> 
>          unify (sub xs ((Var x),y)) (sub ys ((Var x), y)) ts newbs
> unify x y ts bs = 
>     error ("can't do unify with " ++ show x ++ " and " ++  show y ++ "\n")


> {-# INLINE sub #-}

> sub [] (a,b) = []
> sub (x:xs) (a,b) = if x == a then b:sub xs (a,b) else x:sub xs (a,b)

Compose a new binding-pair with an old binding list

> compose :: (Arg,Arg) -> Binding -> Maybe Binding
> compose (a,b) [] = Just [(a,b)]
> compose p1@(a,b) (p2@(c,d):xs) = 
>     if p1==p2 || a==b then Just (p2:xs)
>     else if c==a || d==a then Nothing 
>     else case compose p1 xs of 
>              Nothing -> Nothing
>              Just bs -> Just (p2:bs)

--------------------------------------------------------------------

> getMaxInfreqVar infreqs = maximum (map getMaxVar infreqs)

