$Id: Merger.lhs,v 3.2 2002/07/16 16:28:52 ajc99 Exp $
$Log: Merger.lhs,v $
Revision 3.2  2002/07/16 16:28:52  ajc99
Merger didn't previously have a log record.


> module Main 
> where

> import System ( getArgs )
> import IO     (hPutStrLn,stderr)

> import ADT
> import Dumper
> import DeepSeq
> import HierLearn ( pruneTree )

> main :: IO()
> main = 
>   do 
>     args <- getArgs
>     if length args /= 4
>	then putStrLn "usage: filename chunk_from chunk_to workingdir"
>	else 
>         do
>           let [filename,chunkFromString,chunkToString,workingdir] = args
>               chunkTo   = (read chunkToString) :: Int
>               chunkFrom = (read chunkFromString) :: Int
>		chunkList = [ (show n) | n <- [chunkFrom..chunkTo] ]
>           queries <- collectqueryfiles filename workingdir chunkList
>	    dumpQueries (filename ++ ".merged") workingdir queries

------------------------------------------------------------------


> collectqueryfiles :: String -> String -> [String] -> IO(QueryTree)
> collectqueryfiles filename workingdir [] = 
>    do
>	doesExist <- existsQueryFile (filename ++ ".merged") workingdir
>	if doesExist
>        then 
>          do qorig <- undumpQueries (filename ++ ".merged") workingdir
>	      return $!! qorig
>        else	
>             error "collectqueryfiles: no chunks to collect"
> collectqueryfiles filename workingdir [x] = 
>    do
>       q <- undumpQueries (filename ++ "." ++ x) workingdir
>       putStrLn x
>	doesExist <- existsQueryFile (filename ++ ".merged") workingdir
>	if doesExist
>        then
>          do qorig <- undumpQueries (filename ++ ".merged") workingdir
>	      return $!! (mergeTree q qorig)
>        else	
>             return $!! q
> collectqueryfiles filename workingdir (x:xs) =
>    do
>       tree1 <- collectqueryfiles filename workingdir xs
>       tree2 <- undumpQueries (filename ++ "." ++ x) workingdir
>       putStrLn x
>       return $!! (mergeTree tree1 tree2) 
