$Id: PrettyPrint.lhs,v 3.4 2003/06/30 18:14:01 afc Exp $
$Log: PrettyPrint.lhs,v $
Revision 3.4  2003/06/30 18:14:01  afc
intervals are printed with _ not - now.

Revision 3.3  2003/04/02 17:06:13  afc
Added newVarPred and unusedPred, and Interval.

Revision 3.2  2002/07/16 16:30:46  ajc99
exports prettyassoc too now.

Revision 3.1  2002/05/17 15:52:17  ajc99
fixed bug in display of confidence of rules.

Revision 3.0  2002/04/04 10:44:49  ajc99
Now uses hierarchical background knowledge.

Revision 2.2  2002/02/06 15:21:20  ajc99
Added PackedString

Revision 2.1  2001/12/07 16:20:52  ajc99
Assoc type changed. removed old dead functions.

Revision 2.0  2001/12/04 18:28:27  ajc99
Added bar to this module.

Revision 1.1  2001/09/27 15:06:58  ajc99
Initial revision



> module PrettyPrint(prettyrules, prettyassocs, prettyassoc, bar)
> where

> import ADT
> import PackedString


Rules

> prettyrules :: [ModeNum] -> Mode -> [Rule] -> String
> prettyrules modenums key rules = concatMap (prettyrule modenums key) rules

> prettyrule modenums key (Rule supp1 n1 supp2 n2 head body) = 
>    show supp2 ++ "/" ++ show n2 ++ "    " 
>    ++ show supp2 ++ "/" ++ show supp1 ++ "\n" 
>    ++ headpred modenums key head ++ concatMap (bodypred modenums key) body


---------------------------------------------------------------------

Ordinary associations

> prettyassocs :: [ModeNum] -> Mode -> [Assoc] ->String
> prettyassocs modenums key assocs = 
>   bar 60 ++ "\n" ++ bar 60 ++ "\n" 
>   ++ concatMap (prettyassoc modenums key) assocs

> prettyassoc :: [ModeNum] -> Mode -> Assoc -> String
> prettyassoc modenums key (Assoc preds supp n) =
>     show supp ++ "/" ++ show n ++ " " ++ "\n" 
>     ++ concatMap (bodypred modenums key) preds


----------------------------------------------------------------------

> bodypred modenums key pred = "\t" ++ prettypred modenums key pred  ++ "\n"
> headpred modenums key pred = prettypred modenums key pred ++ " :-\n"


> prettypred :: [ModeNum] -> Mode -> Pred -> String
> prettypred modenums (Mode kname kargs) (Pred functor args) = 
>    let f = 
>         if functor == 0 then kname
>         else if functor == newVarPred then "notequal"
>         else if functor == unusedPred then "dummy"
>         else case (lookupmodenumsname modenums functor) of
>                    Just x -> x
>                    Nothing -> error ("PrettyPrint: prettypred: <" ++
>                               show functor ++ "> not found in modenums") 
>    in f ++ "(" ++ prettyargs args ++ ")"

> lookupmodenumsname [] num = Nothing
> lookupmodenumsname ((ModeNum mnum mname args):rest) num =
>   if num == mnum then Just mname else lookupmodenumsname rest num 


This prints the arguments, with commas in between.

> prettyargs :: [Arg] -> String
> prettyargs [Var v]               = "_" ++ show v
> prettyargs [Atom a]              = unpackPS a
> prettyargs [Interval b e]        = show b ++ "-" ++ show e
> prettyargs ((Var v):rest)        = "_" ++ show v ++ "," ++ prettyargs rest
> prettyargs ((Atom a):rest)       = (unpackPS a) ++ "," ++ prettyargs rest
> prettyargs ((Interval b e):rest) = show b ++ "_" ++ show e ++ ","
>                                    ++ prettyargs rest

-----------------------------------------------------------------------

bar draws a bar n characters across

> bar :: Int -> String
> bar n = ['-' | x <- [1..n]]
