{-
$Id: RemoveDuplicates.hs,v 1.3 2003/09/08 16:28:15 afc Exp $
$Log: RemoveDuplicates.hs,v $
Revision 1.3  2003/09/08 16:28:15  afc
Changed to accommodate subsumes returning a Maybe type

Revision 1.2  2003/04/02 17:08:45  afc
updated rcs headers.


-}

module Main where

import ADT
import FileIO
import InfrequentCheck(subsumes)
import PrettyPrint(prettyassoc)
import Utils

import System(getArgs)
import PackedString
import IO
import Monad(foldM)


main = 
  do args <- getArgs
     hSetBuffering stdout NoBuffering
     if length args /= 2
        then putStrLn "usage: filename patternfile"
        else let [filename,patternfile] = args
             in
             do 
	       (modes,_,key,_,_,_,_) <- readSettings filename
               (bg,hiers)            <-  readBackground filename
	       let 
                 modenums         = compileModes key modes
                 compbg           = compileBG modenums key (bg,hiers)
	         expandedmodenums = map (expandModeConsts bg) modenums   
		 namedAncestorFMs = makeAncestorLookup (snd compbg)

               patts <- parsepatterns modenums patternfile
	    -- putStrLn ("Orig number of patterns: " ++  show (length patts))
               ps    <- foldM (process expandedmodenums key namedAncestorFMs) 
                        [] patts
               return ()


-----------------------------------------------------------------------


process :: [ModeNum] -> Mode -> [(String,AncestorFM)] -> Patterns -> Pattern 
        -> IO(Patterns)
process modes key hiers goodpatts patt@(Assoc p x1 x2) = 
   let maxvar = getMaxVar p in
   if any (ismatch maxvar modes hiers patt) goodpatts then
      return goodpatts
   else
      do  putStr (prettyassoc modes key patt)
          return (patt:goodpatts)


ismatch :: Int -> [ModeNum] -> [(String,AncestorFM)] -> Pattern -> Pattern 
        -> Bool
ismatch maxvar modes hiertrees (Assoc patt x1 x2) (Assoc goodpatt y1 y2) = 
   let newgoodpatt = replaceAllVarsInQuery maxvar goodpatt 
   in
   case subsumes newgoodpatt patt [[]] modes hiertrees of
     Nothing -> False
     Just _ -> 
       case subsumes patt newgoodpatt [[]] modes hiertrees of
          Nothing -> False
          Just _ -> True


